package com.amphinicy.mhp.util;

public abstract class ThreadRunner
    implements Runnable
{
  private Thread thread;

  private boolean started;

  public ThreadRunner()
  {
    started = false;
  }

  /**
   * Starts thread.
   */
  public void start()
  {
    if( !started )
    {
      if( thread == null )
      {
        thread = new Thread( this, getName() );
        thread.setPriority( Thread.NORM_PRIORITY );
        System.out.println( "Starting new thread" );
      }
      else
      {
        System.out.println( "Starting thread" );
      }
      started = true;
      thread.start();
    }
  }

//  synchronized public void pause()
//  {
//    try
//    {
//      this.wait();
//    }
//    catch( InterruptedException ex )
//    {
//      ex.printStackTrace();
//    }
//  }
//
//  synchronized public void cont()
//  {
//    this.notify();
//  }

  /**
   * Stops thread.
   */
  public void stop()
  {
    if( started )
    {
      started = false;
      if( thread != null )
      {
        try
        {
          thread.join( 500 );
        }
        catch( InterruptedException ex )
        {
        }
        thread = null;
      }
    }
  }

  /**
   * Tests if thread is started.
   * @return boolean
   */
  final public boolean isStarted()
  {
    return started;
  }

  /**
   * Change status of thread.
   * @param value boolean
   */
  protected void setStarted(boolean value)
  {
    this.started = value;
  }

  abstract public String getName();
}
